#pragma rtGlobals=1		// Use modern global access method.
#include "Initialization4"

Function UDFrameViewer(destWindow,inWaveString,FrameNumber,contrastLookup,nzMin,nzMax,colorTable,outWaveName)
String destWindow
String inWaveString
Variable FrameNumber
String ContrastLookup
String colorTable
Variable nzMin,nzMax
String outWaveName // Name of the 1-D wave to be written

////////// Test to make sure parameters are reasonable.... ////// 

String destWindowMatch = WinList(destWindow,";","WIN:1")

	If(Strlen(destWindowMatch)==0)	// No such window?
		Print "Busted"
		return 0
	EndIf

 	If(!(WaveExists($inWaveString)))	// No such wave
 		Print "Busted"
 		return 0
 	Else
 		Wave inwave=$inWaveString
 	EndIf
 		

	If(FrameNumber>dimsize($inWaveString,2)-1)
		Print "Busted"
		return 0
	EndIf
	
	
Variable left_min,left_max,bot_min,bot_max
	
	GetAxis/Q/W=$destWindow left;left_min=V_min;left_max=V_max
	GetAxis/Q/W=$destWindow bottom; bot_min=V_min;bot_max=V_max
	
	RMImages(destWindow)
	
	
	Duplicate/O/R=[0,*][0,*][FrameNumber,FrameNumber] inWave $outWaveName
	
	AppendImage/W=$destWindow $outWaveName
	
	ModifyImage/W=$destWindow $outWaveName ctab={nzmin,nzmax,$ColorTable}, lookup=$contrastLookup
End


Function AppImageSettings(destWindow,contrastLookup,nzMin,nzMax,colorTable,theWave)
String destWindow
String contrastLookup
Variable nzMin,nzMax
String colorTable
String theWave

String destWindowMatch = WinList(destWindow,";","WIN:1")

	If(Strlen(destWindowMatch)==0)	// No such window?	
		return 0
	EndIf
	
	If(FindListItem(theWave,ImageNameList(destWindow,";"))==-1)
		return 0

	EndIf
	
//String ImageNameList
//	ModifyImage/W=$destWindow $theWave

End


Function RMImages(destWindow)
String destWindow

String destWindowMatch = WinList(destWindow,";","WIN:1")

	If(Strlen(destWindowMatch)==0)	// No such window?
		return 0
	EndIf

Variable index

	Do	// Don't know why RemoveImage is problematic... this is a pretty dumb kludge
		String ImageList=ImageNameList(destWindow,";")
				
		Do
			String thisImage=StringFromList(index,ImageList)
			If(strlen(thisImage)==0)
				break
			EndIf
				
			RemoveImage/Z $thisImage
			index+=1
		
		While(1)
		
		index=0
	
	While(strlen(ImageList)!=0)

End

